import json

from pyCryptoTrader.binance import Binance
from pyCryptoTrader.stagetrading import StageTrading
from pyCryptoTrader.telegram import TelegramBot

import time
import logging
logging.basicConfig(format='%(asctime)s - %(name)s - %(levelname)s - %(message)s', level=logging.INFO)

class pyCryptoTrader(object):

    def __init__(self,config):
        super().__init__()
        self.config=config
        self.logger=logging.getLogger('pyCryptoTrader')
        self.exchange=Binance(self.config['exchange'])
        self.telegram=TelegramBot(self.config['telegram'],self.exchange)
        for conf in self.config['strat']:
            self.strat=[]
            self.strat.append(StageTrading(conf,self.exchange, self.telegram))
      
    def Run(self):
        while(True):
            for strat in self.strat:
                strat.Update()

    def Stop(self):
        pass
