#telegram bot
import telegram
from telegram.ext import Updater, CommandHandler, Filters, MessageHandler
from telegram.ext.filters import Filters

import logging
logging.basicConfig(format='%(asctime)s - %(name)s - %(levelname)s - %(message)s', level=logging.INFO)

class TelegramBot(object):

      def __init__(self,token,id,exchange):
          super().__init__()
          self.token=token
          self.id=id
          self.exchange=exchange
          self.logger=logging.getLogger('TelegramBot')
          self.updater = Updater(token=token, use_context=True)
          self.dispatcher = self.updater.dispatcher
          self.dispatcher.add_handler(CommandHandler('start', self.Start, Filters.chat(chat_id=id)))
          self.dispatcher.add_handler(CommandHandler('stop', self.Stop, Filters.chat(chat_id=id)))
          self.dispatcher.add_handler(CommandHandler(["profitability", "pb"], self.Profitability, Filters.chat(chat_id=id)))
          self.dispatcher.add_handler(CommandHandler(["portfolio", "pf"], self.Portfolio, Filters.chat(chat_id=id)))
#          self.dispatcher.add_handler(CommandHandler('ping', self.Ping, Filters.chat(chat_id=sid)))
          self.dispatcher.add_handler(CommandHandler('help', self.Help, Filters.chat(chat_id=id)))
          self.dispatcher.add_handler(MessageHandler(Filters.command, self.Unknown, Filters.chat(chat_id=id)))
          self.updater.start_polling()
          self.updater.bot.send_message(chat_id=id, text="Hello, type /help to know the commands.")
          self.status='STOPPED'

      def Start(self, update, context):
            self.status='START'
            #context.bot.send_message(chat_id=update.effective_chat.id, text="Started !")

      def Stop(self, update, context):
            self.status='STOP'
            #context.bot.send_message(chat_id=update.effective_chat.id, text="Stopped !")

      def Profitability(self, update, context):
            text=self.exchange.Profitability()
            context.bot.send_message(chat_id=update.effective_chat.id, text=text)

      def Portfolio(self, update, context):
            results=self.exchange.Portfolio()
            for result in results:
                  context.bot.send_message(chat_id=update.effective_chat.id, text=result)

      def OpenOrders(self, update, context):
            pass
#            results=self.exchange.OpenOrders()
#            for result in results:
#                  context.bot.send_message(chat_id=update.effective_chat.id, text="Order %s Amount:%f Price:%f Cost%s" %(result['type'], result['amount'], result['price'], result['cost'])

      def Unknown(self, update, context):
            context.bot.send_message(chat_id=update.effective_chat.id, text="`Unfortunately, I don't know the command: %s`" %(update.effective_message.text))

      def Help(self, update, context):
            message = "* - My Bot Commands - *\n"
            message += "/start: `Displays my startup message.`\n"
            message += "/ping: `Shows for how long I'm working.`\n"
#            message += "/portfolio or /pf: `Displays my current portfolio.`\n"
#            message += "/open\_orders or /oo: `Displays my current open orders.`\n"
#            message += "/trades\_history or /th: `Displays my trades history since I started.`\n"
#            message += "/profitability or /pb: `Displays the profitability I made since I started.`\n"
            message += "/stop: `Stops me.`\n"
            message += "/help: `Displays this help.`"
            context.bot.send_message(chat_id=update.effective_chat.id, text=message, parse_mode=telegram.ParseMode.MARKDOWN)

#      def Ping(self, update, context):
#            text="Stage Trading alive since %s" %(self.config['stage'].start.strftime("%Y-%m-%d %H:%M:%S"))
#            context.bot.send_message(chat_id=update.effective_chat.id, text=text)

      def Message(self, text):
            self.updater.bot.send_message(chat_id=self.id, text=text)
